# EAR Seminar Tasks Description


## Seminar 5 - Debugging and Testing

1. Configuration of the application is broken - Missing PersistenceConfig import in AppConfig.
2. Long stack traces - find all in ReportDao uses unknown named query and quite a long stacktrace is produced.
3. Show code debugging, the presence of Spring bean proxies instead of direct class instances.
4. Explain test configuration.
5. Task for students:
    - Application does something weird on update - it sets incorrect last editor of report.
    - Verify that correct data goes to server and wrong goes back (in browser, together).
    - Let the students debug the code and find the error.
    - Once error is found, they should write a test reproducing the bug.
    - Fix the bug.
    - Verify the bug is fixed by rerunning the test.
    
## Seminar 6 - Web Services, REST

1. Implement searching of reports by tag in ReportController (together).
2. Create TagController, which allows:
    - To list all tags,
    - To persist a new tag.
3. Verify using a REST client (e.g. Postman) or with a test.

**1 point** for task #2.
    